/*
KindHud: the mod

- 2nd file: Basic defs.
*/

// as you know, the score.
local Min_Scores = function(v, player, x, y, flags)
	-- Kind of basic
	v.drawString(x, y, "Score", flags|V_YELLOWMAP, "thin-center")
	v.drawString(x, y + 7, player.score, flags, "center")
end

// yeah, rings.
local Min_Rings = function(v, player, x, y, flags)
	-- kind of basic 2	
	local funny = (player.rings <= 0 or (player.powers[pw_super] and player.rings <= 20)) and leveltime/5 & 1
	local flash = funny and V_REDMAP or V_YELLOWMAP

	v.drawString(x, y, "Rings", flags|flash, "thin-center")
	v.drawString(x, y + 7, max(0, player.rings), flags, "center")
end

// timer, kinda long.
local Min_Time = function(v, player, x, y, flags)
	local tics, downwards = GetCountdownLogic(v, player.realtime)
	
	local funky = downwards and (tics < 30*TICRATE) and (leveltime % 10 < 5) -- overtime?
	local flash = (downwards and (leveltime % 10 < 5)) and V_REDMAP or V_YELLOWMAP

	-- Time string
	v.drawString(x, y, "Time", flags|flash, "thin-center")

	if (funky == false) then -- overtime!
		local cv_timetic = CV_FindVar("timerres")
		
		local minutes = G_TicsToMinutes(tics)
		local seconds = string.format("%02d", G_TicsToSeconds(tics))
		local tictrn = string.format("%02d", G_TicsToCentiseconds(tics))
		
		local result = ""
		
		local min_sep = ":"
		local cen_sep = "."

		if not tics then
			result = "-" + min_sep + "--" + cen_sep + "--"
		else
			if (cv_timetic.value == 0) then -- Classic
				result = minutes + min_sep + seconds

			elseif (cv_timetic.value == 1 or cv_timetic.value == 2) then -- Centiseconds and Mania
				result = minutes + min_sep + seconds + cen_sep + tictrn

			elseif (cv_timetic.value == 3) then -- Seriously, who uses tics?
				result = tics
			end
		end
		v.drawString(x, y + 7, result, flags, "center")
	end
end

// lives, ft. a shadow!
local Min_Lives = function(v, player, x, y, flags)
	// dont run this if you dont exist.
	if not player.mo then return end
	
	local graycheck = player.spectator and "\x86" or kind.ColorToString(player.skincolor)

	local align1 = (v.stringWidth(skins[player.skin].hudname) > 48) and "thin" or "left"
	local align2 = (string.len(player.name) > 7) and "thin" or "left"
	
	local patch = v.getSprite2Patch(player.skin, SPR2_XTRA, false, C)
	
	// icons
	-- the shadow
	v.draw(x+2, y+3, patch, flags, v.getColormap(TC_BLINK, SKINCOLOR_THECOMPLETELYBLACKCOLOR))
		
	-- the icon
	v.draw(x, y+1, patch, flags, v.getColormap(player.mo.skin, player.mo.color))

	// name
	if not multiplayer then
		v.drawString(x + 15, y - 16, skins[player.skin].hudname, flags|V_YELLOWMAP, align1)
	else
		v.drawString(x + 15, y - 16, graycheck .. player.name, V_ALLOWLOWERCASE|flags, align2)
	end

	// live count
	local namelives, alignlives
	if (gametyperules & GTR_LIVES) then -- does a gametype use lives?
		alignlives = "left"
		
		if (netgame and CV_FindVar("cooplives").value == 0) or (player.lives == INFLIVES) then
			namelives = '\x16'
		elseif (player.lives > 0) then
			namelives = player.lives
		else
			namelives = "DNF"
		end

	elseif (gametyperules & GTR_TEAMS) then -- self-explanatory
		alignlives = "thin"
		y = $ + 1
		
		if player.ctfteam == 1 then -- Red
			namelives = "Red Team"
		elseif player.ctfteam == 2 then -- Blue
			namelives = "Blue Team"
		end

	elseif (gametyperules & GTR_TAG) then -- taggers
		if (player.pflags & PF_TAGIT) then -- are you it?
			alignlives = "left"
			namelives = "IT!"
		else
			alignlives = "thin"
			y = $ + 1
			namelives = "Don't get caught!"
		end

	elseif (gametyperules & GTR_RINGSLINGER) then -- match
		alignlives = "thin"
		y = $ + 1
		namelives = "Free for All"

	elseif (gametyperules & GTR_RACE) or (maptol & TOL_HANGOUT) then -- self-explanatory 2
		alignlives = "left"
		namelives = '\x16'
	end
	v.drawString(x + 15, y - 8, namelives, flags|V_ALLOWLOWERCASE, alignlives)
end

// ugh, speed.
local Min_Speedometer = function(v, player, x, y, flags)
	local drawSpeed = 0
	local thing = ""
	
	if (kind.speedstyle.value == 0) then -- Fracunits
		drawSpeed = player.speed/FRACUNIT
		thing = "Fu/t"

	elseif (kind.speedstyle.value == 1) then -- Miles
		drawSpeed = FixedMul(player.speed, 88465)/FRACUNIT
		thing = "Mph"

	elseif (kind.speedstyle.value == 2) then -- Kilometers
		drawSpeed = FixedMul(player.speed, 142371)/FRACUNIT
		thing = "Km/h" 
	end
	
	local str = string.format(kind.ColorToString(player.skincolor) .. "Speed: \x80" .. "%1d " .. thing, drawSpeed)
	v.drawString(x, y, str, flags, "thin")
end

local Min_Powerstones = function(v, player)
	local calc = player.powers[pw_invulnerability] and (player.powers[pw_invulnerability] == player.powers[pw_sneakers])
				 and (leveltime/7) & 1 

	-- the drawing
	for i = 0, 6, 1 do
		local flags = V_HUDTRANSHALF
		local x = 8 + (9 * i)
		local y = kind.speedometer.value and 146 or 158
		
		local patch = v.cachePatch("TEMER" .. (i + 1))
		
		if (player.powers[pw_emeralds] & (EMERALD1 << i)) or calc then 
			flags = V_HUDTRANS
		end
		
		v.draw(x, y, patch, flags|V_SNAPTOLEFT|V_SNAPTOBOTTOM, nil)
	end
end

// Result of all of this thing
kind.DrawMinHud = function(v, player)
	local spectatorflag = player.spectator and V_HUDTRANSHALF or V_HUDTRANS
	
	-- things that should not be drawn when spectating.
	if not player.spectator then
		-- speedometer
		if (kind.speedometer.value) then
			Min_Speedometer(v, player, 16 - 8, 190 - 32, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_PERPLAYER|V_HUDTRANS)
		end
			
		-- emeralds
		if (gametyperules & GTR_POWERSTONES) and not player.spectator then
			Min_Powerstones(v, player)
		end
	end

	// everything.
	if (maptol & TOL_NIGHTS) or G_IsSpecialStage() then return end
		
	Min_Lives(v, player, 16, 190, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
	Min_Scores(v, player, 33, 6, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|spectatorflag)
	Min_Time(v, player, 160, 6, V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
	Min_Rings(v, player, 283, 6, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|spectatorflag)
end