/*
KindHud: the mod

- 3rd file: 3D Blast special!
*/

local Blast_Time = function(v, player, x, y, flags)
	local tics, downwards = GetCountdownLogic(v, player.realtime)
	
	local funky = downwards and (tics < 30*TICRATE) and (leveltime % 10 < 5) -- overtime?
	
	if (funky == false) then -- overtime!
		local cv_style = CV_FindVar("timerres").value
		local qte_patch = v.cachePatch("3D_QTE")
		local dot_patch = v.cachePatch("3D_DOT")
		
		local mins = G_TicsToMinutes(tics, true)
		local secs = string.format("%02d", G_TicsToSeconds(tics))
		local cent = string.format("%02d", G_TicsToCentiseconds(tics))
		
		if (cv_style < 3) then
			-- minutes
			DrawCustomNum(v, x + 7, y, mins, "3D_NUM", flags, -1)
			
			-- quote
			v.draw(x + 7, y, qte_patch, flags)
			
			-- seconds
			DrawCustomNum(v, x + 14, y, secs, "3D_NUM", flags, 1)
			
			if (cv_style > 0) then
				v.draw(x + 28, y, dot_patch, flags)
				
				DrawCustomNum(v, x + 35, y, cent, "3D_NUM", flags, 1)
			end
		else
			-- tics
			DrawCustomNum(v, x, y, tics, "3D_NUM", flags, 1)
		end
	end
end

local Blast_Rings = function(v, player, x, y, flags)
	local ring_patch = v.cachePatch("3D_RINGS")
	
	if not (player.rings <= 0 and leveltime/5 & 1) then
		v.draw(x, y, ring_patch, flags)
	end
	
	DrawCustomNum(v, x + 45, y, max(0, player.rings), "3D_NUM", flags, 1)
end

-- umm...
local Blast_Score = function(v, player, x, y, flags)
	DrawCustomNum(v, x, y, player.score, "3D_NUM", flags, -1)
end

local Blast_Lives = function(v, player, x, y, flags)
	// dont run this if you dont exist.
	if not player.mo then return end
	
	local xtra_patch = v.cachePatch("STLIVEBK")
	local icon_patch = v.getSprite2Patch(player.skin, SPR2_XTRA, (player.powers[pw_super] and true or false), 0)
	local x_patch = v.cachePatch("3D_X")
		
	// skin icon
	v.drawScaled(x << FRACBITS, y << FRACBITS, FRACUNIT/2, xtra_patch, flags)
	v.drawScaled(x << FRACBITS, y << FRACBITS, FRACUNIT/2, icon_patch, flags, v.getColormap(player.mo.skin, player.mo.color))

	// count
	v.draw(x + 17, y + 10, x_patch, flags)
	DrawCustomNum(v, x + 24, y + 1, max(0, player.lives), "3D_NUM", flags, 1)
end

// again, a function to draw it.
kind.DrawBlastHud = function(v, player)
	local spectatorflag = player.spectator and V_HUDTRANSHALF or V_HUDTRANS
	
	// yeah.
	if (maptol & TOL_NIGHTS) or G_IsSpecialStage() then return end

	Blast_Lives(v, player, 16, 176, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS)
	Blast_Time(v, player, 16, 33, V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS|V_PERPLAYER)
	Blast_Rings(v, player, 16, 13, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|spectatorflag)
	Blast_Score(v, player, 304, 13, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER|spectatorflag)
end